(define (domain exblock)
  (:requirements :typing :strips :equality :probabilistic-effects :rewards)
  (:types box)
  (:predicates (clear ?X - box)
               (holding ?X - box)
               (noDetonated ?X - box)
               (noDestroyed ?X - box)
               (on ?X - box ?Y - box)
               (emptyhand) (noDestroyedTable))
  (:action pickUp
    :parameters (?X - box ?Y - box)
    :precondition (and (emptyhand) (clear ?X) (on ?X ?Y) (noDestroyed ?X))
    :effect (and (holding ?X) (clear ?Y) (not (emptyhand)) (not (on ?X ?Y)) )
  )
  (:action pickUpFromTable
    :parameters (?X - box)
    :precondition (and (emptyhand) (clear ?X) (onTable ?X) (noDestroyed ?X))
    :effect (and (holding ?X) (not (emptyhand)) (not (onTable ?X)) )
  )
  (:action putDown
    :parameters (?X - box)
    :precondition (and (holding ?X) (noDestroyedTable) (not (noDetonated ?X)) )
    :effect (and (emptyhand) (onTable ?X) (not (holding ?X)) )
  )
  (:action putDown
    :parameters (?X - box)
    :precondition (and (holding ?X) (noDestroyedTable) (noDetonated ?X))
    :effect (and (emptyhand) (onTable ?X) (not (holding ?X))
                 (probabilistic 0.4 (and (not (noDestroyedTable)) (not (noDetonated ?X)) ) )
            )
  )
  (:action putOnBlock
    :parameters (?X - box ?Y - box)
    :precondition (and (holding ?X) (clear ?Y) (noDestroyed ?Y) (not (holding ?Y)) (not (noDetonated ?X)) )
    :effect (and (emptyhand) (on ?X ?Y) (not (holding ?X)) (not (clear ?Y)) )
  )
  (:action putOnBlock
    :parameters (?X - box ?Y - box)
    :precondition (and (holding ?X) (clear ?Y) (noDestroyed ?Y) (not (holding ?Y)) (noDetonated ?X) )
    :effect (and (emptyhand) (on ?X ?Y) (not (holding ?X)) (not (clear ?Y))
                 (probabilistic 0.2 (and (not (noDestroyed ?Y)) (not (noDetonated ?X))) )
            )
  )

)
