(define (domain kitchen)
  (:requirements :typing :strips :equality :probabilistic-effects :rewards)
  (:types plate cup fork)
  (:predicates (clear ?X - plate)
               (clear ?X - cup)
               (clear ?X - fork)
               (broken ?X - plate)
               (broken ?X - cup)
               (broken ?X - fork)
               (onTable ?X - plate)
               (onTable ?X - cup)
               (onTable ?X - fork)
               (on ?X - plate ?Y - plate)
               (on ?X - plate ?Y - cup)
               (on ?X - plate ?Y - fork)
               (on ?X - cup ?Y - plate)
               (on ?X - cup ?Y - cup)
               (on ?X - cup ?Y - fork)
               (on ?X - fork ?Y - plate)
               (on ?X - fork ?Y - cup)
               (on ?X - fork ?Y - fork)
               (finished)
  )
  (:action finish_action
    :parameters ()
    :precondition (and (not (finished)))
    :effect (and (finished) 
                (when (not (finished)) (increase (reward) 14.8))
                (when (exists (?plate - plate) (broken ?plate))  (increase (reward) -5.0))
                (when (exists (?cup   - cup)   (broken ?cup))    (increase (reward) -5.0))
                (when (exists (?fork  - fork)  (broken ?fork))   (increase (reward) -5.0))
                (when (exists (?plate - plate) (onTable ?plate)) (increase (reward) -1.0))
                (when (exists (?cup   - cup)   (onTable ?cup))   (increase (reward) -1.0))
                (when (exists (?fork  - fork)  (onTable ?fork))  (increase (reward) -1.0))
            )
  )
)

