(define (domain kitchen)
  (:requirements :typing :strips :equality :probabilistic-effects :rewards)
  (:types box)
  (:predicates (clear ?X - plate)
               (clear ?X - cup)
               (clear ?X - fork)
               (broken ?X - plate)
               (broken ?X - cup)
               (broken ?X - fork)
               (onTable ?X - plate)
               (onTable ?X - cup)
               (onTable ?X - fork)
               (on ?X - plate ?Y - plate)
               (on ?X - plate ?Y - cup)
               (on ?X - plate ?Y - fork)
               (on ?X - cup ?Y - plate)
               (on ?X - cup ?Y - cup)
               (on ?X - cup ?Y - fork)
               (on ?X - fork ?Y - plate)
               (on ?X - fork ?Y - cup)
               (on ?X - fork ?Y - fork)
               (finished)
  )
  (:action putPlateOn
    :parameters (?X - plate ?Y - plate)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
  )
  (:action putPlateOn
    :parameters (?X - plate ?Y - cup)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (probabilistic 0.7 (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
                                0.3 (and (broken ?X) )
                 )
            )
  )
  (:action putPlateOn
    :parameters (?X - plate ?Y - fork)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (probabilistic 0.7 (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
                                0.3 (and (broken ?X) )
                 )
            )
  )
  (:action putCupOn
    :parameters (?X - cup ?Y - plate)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
  )
  (:action putCupOn
    :parameters (?X - cup ?Y - cup)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
  )
  (:action putCupOn
    :parameters (?X - cup ?Y - fork)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (probabilistic 0.5 (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
                                0.5 (and (broken ?X) )
                 )
            )
  )
  (:action putForkOn
    :parameters (?X - fork ?Y - plate)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
  )
  (:action putForkOn
    :parameters (?X - fork ?Y - cup)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
  )
  (:action putForkOn
    :parameters (?X - fork ?Y - fork)
    :precondition (and (clear ?Y) (clear ?X) (onTable ?X) (not (broken ?X)) )
    :effect (and (not (clear ?Y)) (on ?X ?Y) (not (onTable ?X)) )
  )
  (:action removePlate
    :parameters (?X - plate ?Y - plate)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action removePlate
    :parameters (?X - plate ?Y - cup)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action removePlate
    :parameters (?X - plate ?Y - fork)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action removeCup
    :parameters (?X - cup ?Y - plate)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action removeCup
    :parameters (?X - cup ?Y - cup)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action removeCup
    :parameters (?X - cup ?Y - fork)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action removeFork
    :parameters (?X - fork ?Y - plate)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action removeFork
    :parameters (?X - fork ?Y - cup)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action removeFork
    :parameters (?X - fork ?Y - fork)
    :precondition (and (on ?X ?Y) (clear ?X) (not (broken ?X)))
    :effect (and (clear ?Y) (not (on ?X ?Y)) (onTable ?X) )
  )
  (:action finish_action
    :parameters ()
    :precondition (and (not (finished)))
    :effect (and (finished) 
                (when (not (finished)) (increase (reward) 14.8))
                (when (broken plate1) (increase (reward) -5.0))
                (when (broken plate2) (increase (reward) -5.0))
                (when (broken plate3) (increase (reward) -5.0))
                (when (broken cup1)   (increase (reward) -5.0))
                (when (onTable plate1) (increase (reward) -1.0))
                (when (onTable plate2) (increase (reward) -1.0))
                (when (onTable plate3) (increase (reward) -1.0))
                (when (onTable cup1) (increase (reward) -1.0))
            )
  )
)
