(define (domain kitchen)
  (:requirements :typing :strips :equality :probabilistic-effects :rewards)
  (:types plate cup fork)
  (:predicates                (clear ?X - cup)
               (clear ?X - plate)
               (finished )
               (on ?X - cup ?Y - plate)
               (on ?X - plate ?Y - plate)
               (onTable ?X - cup)
               (onTable ?X - plate)
  )
  (:action finish_action
   :parameters ()
   :precondition (and (not (finished )) )
   :effect (and (probabilistic  1 (and (finished ) ))
                (when  (and (not (finished )) ) (increase (reward) 14.8))
                (when  (exists (?plate - plate ) (and (broken ?plate ) (not (finished )) )) (decrease (reward) 5))
                (when  (exists (?cup - cup ) (and (broken ?cup ) (not (finished )) )) (decrease (reward) 5))
                (when  (exists (?fork - fork ) (and (broken ?fork ) (not (finished )) )) (decrease (reward) 5))
                (when  (exists (?plate - plate ) (and (not (finished )) (onTable ?plate ) )) (decrease (reward) 1))
                (when  (exists (?cup - cup ) (and (not (finished )) (onTable ?cup ) )) (decrease (reward) 1))
                (when  (exists (?fork - fork ) (and (not (finished )) (onTable ?fork ) )) (decrease (reward) 1))
           )
  )
  (:action removeCup
   :parameters (?X - cup ?Y - plate)
   :precondition (and (not (finished )) (not (on ?X ?Y )) )
   :effect (and (probabilistic )
           )
  )
  (:action removeCup
   :parameters (?X - cup ?Y - plate)
   :precondition (and (not (finished )) (on ?X ?Y ) )
   :effect (and (probabilistic  1 (and (clear ?Y ) (not (on ?X ?Y )) (onTable ?X ) ))
           )
  )
  (:action putCupOn
   :parameters (?X - cup ?Y - plate)
   :precondition (and (clear ?Y ) (not (finished )) (not (onTable ?X )) )
   :effect (and (probabilistic )
           )
  )
  (:action putCupOn
   :parameters (?X - cup ?Y - plate)
   :precondition (and (clear ?Y ) (not (finished )) (onTable ?X ) )
   :effect (and (probabilistic  1 (and (not (clear ?Y )) (on ?X ?Y ) (not (onTable ?X )) ))
           )
  )
  (:action putCupOn
   :parameters (?X - cup ?Y - plate)
   :precondition (and (not (clear ?Y )) (not (finished )) )
   :effect (and (probabilistic )
           )
  )
  (:action putPlateOn
   :parameters (?X - plate ?Y - plate)
   :precondition (and (clear ?X ) (clear ?Y ) (not (finished )) (onTable ?X ) )
   :effect (and (probabilistic  1 (and (not (clear ?Y )) (on ?X ?Y ) (not (onTable ?X )) ))
           )
  )
  (:action putPlateOn
   :parameters (?X - plate ?Y - plate)
   :precondition (and (not (clear ?Y )) (not (finished )) (onTable ?X ) )
   :effect (and (probabilistic )
           )
  )
  (:action putPlateOn
   :parameters (?X - plate ?Y - plate)
   :precondition (and (not (clear ?X )) (not (finished )) (onTable ?X ) )
   :effect (and (probabilistic )
           )
  )
  (:action putPlateOn
   :parameters (?X - plate ?Y - plate)
   :precondition (and (not (finished )) (not (onTable ?X )) )
   :effect (and (probabilistic )
           )
  )
)
