(define (domain crossing)
  (:requirements :typing :strips :equality :probabilistic-effects :rewards)
  (:types xpos ypos)
  (:predicates                (GOAL ?X - xpos ?Y - ypos)
               (MAX-XPOS ?X - xpos)
               (MAX-YPOS ?X - ypos)
               (MIN-YPOS ?X - ypos)
               (NORTH ?X - ypos ?Y - ypos)
               (WEST ?X - xpos ?Y - xpos)
               (obstacle-at ?X - xpos ?Y - ypos)
               (robot-at ?X - xpos ?Y - ypos)
  )
  (:action move-east
   :parameters ()
   :precondition (exists (?X - xpos ?Y - ypos ) (and (MAX-XPOS ?X ) (MIN-YPOS ?Y ) (not (robot-at ?X ?Y )) ) )
   :effect (and (probabilistic  1 (and (robot-at ?X ?Y ) ))
           )
  )
  (:action move-west
   :parameters ()
   :precondition (exists (?X - xpos ?Z - xpos ?Y - ypos ) (and (WEST ?Z ?X ) (robot-at ?Z ?Y ) ) )
   :effect (and (probabilistic  1 (and (robot-at ?X ?Y ) ))
           )
  )
  (:action move-west
   :parameters ()
   :precondition (exists (?X - xpos ?Y - ypos ?Z - ypos ) (and (not (GOAL ?X ?Y )) (MAX-XPOS ?X ) (robot-at ?X ?Z ) ) )
   :effect (and (probabilistic  1 (and (obstacle-at ?X ?Y ) ))
           )
  )
  (:action noaction
   :parameters ()
   :precondition (exists (?X - xpos ?Z - xpos ?Y - ypos ) (and (WEST ?Z ?X ) (obstacle-at ?Z ?Y ) ) )
   :effect (and (probabilistic  1 (and (obstacle-at ?X ?Y ) ))
           )
  )
  (:action noaction
   :parameters ()
   :precondition (exists (?X - xpos ?Y - ypos ) (and (MAX-XPOS ?X ) (not (MAX-YPOS ?Y )) (not (MIN-YPOS ?Y )) (not (obstacle-at ?X ?Y )) ) )
   :effect (and (probabilistic  0.0666667 (and (obstacle-at ?X ?Y ) ))
           )
  )
)
